functor ContextFn(Lang : sig type con type kind end)  =
  struct

    type con = Lang.con
    type kind = Lang.kind

    type expvar = Variables.exp Variable.var
    type convar = Variables.con Variable.var

    datatype dec =
      DecExpCon of expvar * con
    | DecConKind of convar * kind
  
    (* left is most recent *)
    type context = dec list

    val empty = []

    (* NB: newest dec first *)
    fun extend ctx dec = dec :: ctx
    fun extend_many ctx decs = List.revAppend (decs, ctx)

    fun list_findSome pfun l =
        case l of
            [] => NONE
          | x::xs =>
                (case pfun x of
                    NONE => list_findSome pfun xs
                  | SOME y => SOME y)

    fun lookup_expvar ctx expvar =
        list_findSome
            (fn DecExpCon (x, c) =>
                    if Variable.eq (expvar, x) then SOME c else NONE
              | _ => NONE)
            ctx

    fun lookup_convar ctx convar =
        list_findSome
            (fn DecConKind (cx, k) =>
                    if Variable.eq (convar, cx) then SOME k else NONE
              | _ => NONE)
            ctx
    
    fun expvar_component ctx =
      List.filter (fn DecExpCon _ => true | _ => false) ctx
    fun convar_component ctx =
      List.filter (fn DecConKind _ => true | _ => false) ctx

    fun to_list ctx = ctx
  end
