signature CONTEXT =
  sig
    type context

    type con
    type kind
    
    type expvar = Variables.exp Variable.var
    type convar = Variables.con Variable.var

    datatype dec =
        DecExpCon of expvar * con
      | DecConKind of convar * kind

    val empty : context
    val extend : context -> dec -> context
    val extend_many : context -> dec list -> context

    val lookup_convar : context -> convar -> kind option
    val lookup_expvar : context -> expvar -> con option

    (* Leaves only the *var declarations *)
    val expvar_component : context -> context
    val convar_component : context -> context

    val to_list : context -> dec list
  end
