structure Variable :> VARIABLE =
  struct
    type 'a var = string * int (* original name, unique int *)

    local
      val r = ref 0
    in
      fun fresh_int () =
        let val x = !r
            val () = r := !r + 1
        in
            x
        end
    end

    fun newNamed s = (s, fresh_int ())
    fun new () = newNamed "var"
    fun freshen (s, _) = newNamed s

    fun toString (s, n) = s ^ "_" ^ Int.toString n

    fun eq ((_, n1 : int), (_, n2)) = n1 = n2
    (* NB: not the "natural" order... *)
    fun compare ((_, n1), (_, n2)) = Int.compare (n1, n2)

  end
