signature ELABORATE =
  sig
    exception Elab of string
    exception Error of string

    type tcontext = (IL.label * IL.dec) list

    val elab_ty : tcontext -> EL.ty -> IL.con
    val elab_exp : tcontext -> EL.exp -> IL.exp * IL.con

    val elab_bindings : tcontext -> EL.binding list
                     -> IL.sbnd list * IL.sdec list
    val elab_specs : tcontext -> EL.spec list -> IL.sdec list

    val elab_strexp : tcontext -> EL.strexp -> IL.module * IL.signat
    val elab_sigexp : tcontext -> EL.sigexp -> IL.signat

    val elab_program : tcontext -> EL.binding list
                    -> IL.sbnd list * IL.sdec list
  end
