signature ILSTATIC =
  sig
    type context = IL.dec list
    type tcontext = (IL.label * IL.dec) list

    exception Subkind
    exception Subsig
    exception Check of string
    exception Error of string

    (* raises Subkind if false *)
    val subkind : context -> IL.kind -> IL.kind -> unit

    (* raise Equiv if false, or Occurs if occurs-check fails  *)
    val equiv_kind : context -> IL.kind -> IL.kind -> unit
    val equiv_con : context -> IL.con -> IL.con -> IL.kind -> unit

    (* raises Subsig if false *)
    val subsig : context -> IL.signat -> IL.signat -> unit

    val whnf : context -> IL.con -> IL.con

    val check_kind : context -> IL.kind -> unit

    val synth_mod_sig : context -> IL.module -> IL.signat
    val check_mod_sig : context -> IL.module -> IL.signat -> string -> unit

    val synth_con_kind : context -> IL.con -> IL.kind
    val check_con_kind : context -> IL.con -> IL.kind -> string -> unit

    val synth_exp_con : context -> IL.exp -> IL.con
    val check_exp_con : context -> IL.exp -> IL.con -> string -> unit

    (* Type Inference Support Structure *)
    structure Inference : INFERENCE

  end
