signature IL1STATIC =
  sig
    type context = IL1Context.context

    exception Equiv
    exception Occurs
    exception Subkind
    exception Subsig
    exception Check of string
    exception Error of string

    (* raises Subkind if false *)
    val subkind : context -> IL1.kind -> IL1.kind -> unit

    (* raise Equiv if false, or Occurs if occurs-check fails  *)
    val equiv_kind : context -> IL1.kind -> IL1.kind -> unit
    val equiv_con : context -> IL1.con -> IL1.con -> IL1.kind -> unit

    (* raises Subsig if false *)
    val subsig : context -> IL1.signat -> IL1.signat -> unit

    val whnf : context -> IL1.con -> IL1.con

    val check_kind : context -> IL1.kind -> unit

    val synth_mod_sig : context -> IL1.module -> IL1.signat
    val check_mod_sig : context -> IL1.module -> IL1.signat -> string -> unit

    val synth_con_kind : context -> IL1.con -> IL1.kind
    val check_con_kind : context -> IL1.con -> IL1.kind -> string -> unit

    val synth_exp_con : context -> IL1.exp -> IL1.con
    val check_exp_con : context -> IL1.exp -> IL1.con -> string -> unit
  end
