signature IL2STATIC =
  sig
    structure Ctx : CONTEXT
                    where type kind = IL2.kind
                      and type con = IL2.con

    type context = Ctx.context

    exception Equiv
    exception Subkind
    exception Check of string
    exception Error of string

    (* raises Subkind if false *)
    val subkind : context -> IL2.kind -> IL2.kind -> unit

    (* raise Equiv if false, or Occurs if occurs-check fails  *)
    val equiv_kind : context -> IL2.kind -> IL2.kind -> unit
    val equiv_con : context -> IL2.con -> IL2.con -> IL2.kind -> unit

    val whnf : context -> IL2.con -> IL2.con

    val check_kind : context -> IL2.kind -> bool

    val synth_con_kind : context -> IL2.con -> IL2.kind
    val check_con_kind : context -> IL2.con -> IL2.kind -> bool

    val synth_exp_con : context -> IL2.exp -> IL2.con
    val check_exp_con : context -> IL2.exp -> IL2.con -> bool

    val synth_mod_sig : context -> IL2.module -> IL2.signat
    val check_mod_sig : context -> IL2.module -> IL2.signat -> bool

    val check_signat : context -> IL2.signat -> bool
    val equiv_signat : context -> IL2.signat -> IL2.signat -> bool
    val sub_signat : context -> IL2.signat -> IL2.signat -> bool
  end
