signature IL4STATIC =
  sig
    structure Ctx : CONTEXT 
      where type con = IL4.con
            and type kind = IL4.kind

    exception Equiv
    exception Check of string
    exception Error of string

    val equiv_kind : IL4.kind -> IL4.kind -> bool

    (* raise Equiv if false *)
    val equiv_con : Ctx.context -> IL4.con -> IL4.con -> IL4.kind -> unit

    val whnf : IL4.con -> IL4.con

    (* expand a projection from a ConMu into its substitution instance *)
    val expand : Ctx.context -> IL4.con -> IL4.con

    val synth_con_kind : Ctx.context -> IL4.con -> IL4.kind
    val check_con_kind : Ctx.context -> IL4.con -> IL4.kind -> string -> unit

    val synth_value_con : Ctx.context -> IL4.value -> IL4.con
    val check_value_con : Ctx.context -> IL4.value -> IL4.con -> string -> unit

    val synth_bnd_dec : Ctx.context -> IL4.bnd -> Ctx.dec

    val check_exp : Ctx.context -> IL4.exp -> unit
  end
