signature IL5STATIC =
  sig
    structure Ctx : CONTEXT 
      where type con = IL5.con
            and type kind = IL5.kind
    
    exception Equiv
    exception Check of string
    exception Error of string

    val equiv_kind : IL5.kind -> IL5.kind -> bool

    (* raise Equiv if false *)
    val equiv_con : Ctx.context -> IL5.con -> IL5.con -> IL5.kind -> unit

    val whnf : IL5.con -> IL5.con

    (* expand a projection from a ConMu into its substitution instance *)
    val expand : Ctx.context -> IL5.con -> IL5.con

    val synth_con_kind : Ctx.context -> IL5.con -> IL5.kind
    val check_con_kind : Ctx.context -> IL5.con -> IL5.kind -> string -> unit

    val synth_value_con : Ctx.context -> IL5.value -> IL5.con
    val check_value_con : Ctx.context -> IL5.value -> IL5.con -> string -> unit

    val synth_bnd_dec : Ctx.context -> IL5.bnd -> Ctx.dec

    val check_exp : Ctx.context -> IL5.exp -> unit
  end
