signature IL6STATIC =
  sig
    structure Ctx : CONTEXT 
      where type con = IL6.con
            and type kind = IL6.kind
    
    exception Equiv
    exception Check of string
    exception Error of string

    val equiv_kind : IL6.kind -> IL6.kind -> bool

    (* raise Equiv if false *)
    val equiv_con : Ctx.context -> IL6.con -> IL6.con -> IL6.kind -> unit

    val whnf : IL6.con -> IL6.con

    (* expand a projection from a ConMu into its substitution instance *)
    val expand : Ctx.context -> IL6.con -> IL6.con

    val synth_con_kind : Ctx.context -> IL6.con -> IL6.kind
    val check_con_kind : Ctx.context -> IL6.con -> IL6.kind -> string -> unit

    val synth_value_con : Ctx.context -> IL6.value -> IL6.con
    val check_value_con : Ctx.context -> IL6.value -> IL6.con -> string -> unit

    val synth_word_con : Ctx.context -> IL6.word -> IL6.con
    val check_word_con : Ctx.context -> IL6.word -> IL6.con -> string -> unit

    val synth_bnd_dec : Ctx.context -> IL6.bnd -> Ctx.dec

    val check_exp : Ctx.context -> IL6.exp -> unit

    val check_program : IL6.program -> unit
  end
