(* initial fixity for identifiers *)

signature FIX_CONTEXT =
sig
    type context

    val initial : context

    (* [diff ctx1 ctx2] is the ctx such that [join ctx ctx2 = ctx1],
       assuming that ctx2 is a subcontext of ctx1 *)
    val diff : context -> context -> context
    (* [join ctx1 ctx2] is the context with all the bindings in ctx1
       and ctx2, with ctx1's taking precedence over ctx2's *)
    val join : context -> context -> context

    val isInfix : context -> string -> bool
    val getInfix : context -> string
                           (* returns the id passed in, to make the parser
                              easier to write -- search getInfix in parser *)
                           -> (string * (int * Parsing.associativity)) option

    val addInfix : context -> string -> int * Parsing.associativity -> context
    val delInfix : context -> string -> context
end
