signature PARSER =
  sig
    type label = string
    type ident = string

    exception Internal of string
    exception Parse of Pos.pos * string

    (* core *)
    val parseTy : (BigEL.ty, Tokens.token) Parsing.parser
    val parsePat : (BigEL.pat, Tokens.token) Parsing.parser
    val parseExp : (BigEL.exp, Tokens.token) Parsing.parser
    val parseDecs : (BigEL.dec list, Tokens.token) Parsing.parser

    (* modules *)
    val parseStrExp : (BigEL.strexp, Tokens.token) Parsing.parser
    val parseSigExp : (BigEL.sigexp, Tokens.token) Parsing.parser
    val parseStrDecs : (BigEL.strdec list, Tokens.token) Parsing.parser

    (* programs *)
    val parseTopDecs : (BigEL.topdec list, Tokens.token) Parsing.parser

    val parseFile : string -> BigEL.program
    val parseString : string -> BigEL.program
  end
