/* guardedints.c
 * Generates an n element array where the value of element n is n.
 * Then forces a GC and checks if the array is still valid.
 */
/* give this round 1800 bytes of memory to make sure a gc gets forced */

#include <runtime.h>
extern hotcint_t exception_tag_counter;
void* hotc_mainfun(hotc_t* arg);

#define NUM_FIELDS 100
#define INITIAL_ALLOC (NUM_FIELDS + 1 + NUM_FIELDS * 2)

void* hotc_mainfun(hotc_t* arg) {
    hotc_check(arg, INITIAL_ALLOC);
    hotc_t arr = (hotc_t)hotc_alloc(NUM_FIELDS, FALSE);
    int x;
    for(x = 1; x <= NUM_FIELDS; x++) {
      hotc_t elem = (hotc_t)hotc_alloc(1, TRUE);
      set(elem, 1, x);
      set(arr, x, elem);
    }
    /* force a gc by allocating some memory we don't use*/
    hotc_check(&arr, 100);
    hotc_t unused = (hotc_t)hotc_alloc(100, FALSE);
    hotc_check(&arr, 100);
    for(x = 1; x <= NUM_FIELDS; x++) {
      hotc_t elem = get(arr, x);
      hotcint_t i = (get(elem, 1)).num;
      if(i != x) {
        printf("field %d incorrectly contains%d.\n", x, i);
        exit(CONSISTENCY);
      }
    }
    hotc_halt(*arg);
}

